#include <fstream>
#include <iostream>
#include <sstream>
#include <vector>

#include "Algorithms.h"
#include "DoubleQueueStack.h"
#include "Queue.h"
#include "Stack.h"

void checkStack() {
	std::ofstream task1("../../Out/Lab4/task1.out");
	Stack<int, 5> s;

	std::cout << "========== Checking stack methods  ==========\n";

    for (int i = 46; i < 51; i++) {
        s.push(i);
    }

    std::cout << "Stack: " << s << std::endl;
    task1 << s << std::endl;
}

void checkQueue() {
	std::ofstream task2("../../Out/Lab4/task2.out");
	Queue<int, 5> q;

    std::cout << "========== Checking queue methods ==========\n";

    for (int i = 0; i < 5; i++) {
        q.enqueue(i);
    }

    std::cout << "Queue: " << q << std::endl;
    task2 << q << std::endl;
}

void checkBalancedParentheses() {
	std::ofstream task3("../../Out/Lab4/task3.out");
	std::cout << "========== Balanced parentheses check ==========\n";
    std::ostringstream oss;

    oss << "Checking \"[({()})][{}]()\": " <<
        Algorithms::checkBalancedParentheses("[({()})][{}]()") << std::endl;
    std::cout << oss.str();
    task3 << oss.str();
    oss.str("");

    oss << "Checking \"{}[(])\": " <<
        Algorithms::checkBalancedParentheses("{}[(])") << std::endl;
    std::cout << oss.str();
    task3 << oss.str();
    oss.str("");

    oss << "Checking \"\": " <<
        Algorithms::checkBalancedParentheses("") << std::endl;
    std::cout << oss.str();
    task3 << oss.str();
    oss.str("");

    oss << "Checking \"(\": " <<
        Algorithms::checkBalancedParentheses("(") << std::endl;
    std::cout << oss.str();
    task3 << oss.str();
    oss.str("");

    oss << "Checking \"]\": " <<
        Algorithms::checkBalancedParentheses("]") << std::endl;
    std::cout << oss.str();
    task3 << oss.str();
    oss.str("");
}

void checkRadixSort() {
	std::ofstream task4("../../Out/Lab4/task4.out");
	std::cout << "========== Radix sort check ==========\n";

    std::vector<int> v;
    v.push_back(50);
    v.push_back(45);
    v.push_back(75);
    v.push_back(90);
    v.push_back(2);
    v.push_back(24);
    v.push_back(802);
    v.push_back(66);

    std::cout << "Before sort: ";
    task4 << "Before sort: ";

    for (unsigned int i = 0; i < v.size(); i++) {
        std::cout << v[i] << " ";
        task4 << v[i] << " ";
    }

    std::cout << std::endl;
    task4 << std::endl;

    Algorithms::radixSort(v);

    std::cout << "After sort: ";
    task4 << "After sort: ";

    for (unsigned int i = 0; i < v.size(); i++) {
        std::cout << v[i] << " ";
        task4 << v[i] << " ";
    }

    std::cout << std::endl;
}

void checkReverseQueue() {
	std::ofstream bonus1("../../Out/Lab4/bonus1.out");
	Queue<int, 20> queueB;

	std::cout << "========== Reverse queue check (bonus) ==========\n";

    for (int i = 0; i < 10; i++) {
        queueB.enqueue(i + 1);
    }

    std::cout << "QueueB before reverse: " << queueB << std::endl;
    bonus1 << "QueueB before reverse: " << queueB << std::endl;
    Algorithms::reverseQueue(queueB);
    std::cout << "QueueB after reverse: " << queueB << std::endl;
    bonus1 << "QueueB after reverse: " << queueB << std::endl;
}

void checkDoubleStackQueue() {
	std::ofstream bonus2("../../Out/Lab4/bonus2.out");

	std::cout << "========== Double queue stack (bonus) ==========\n";
    DoubleQueueStack<char, 10> doubleQueueStack;
    doubleQueueStack.push('a');
    doubleQueueStack.push('b');
    doubleQueueStack.push('c');
    doubleQueueStack.push('d');

    std::cout << "DoubleQueueStack: " << doubleQueueStack << std::endl;
    bonus2 << "DoubleQueueStack: " << doubleQueueStack << std::endl;
    doubleQueueStack.pop();
    doubleQueueStack.pop();
    std::cout << "After popping 2 elements: " << doubleQueueStack << std::endl;
    bonus2 << "After popping 2 elements: " << doubleQueueStack << std::endl;
    doubleQueueStack.push('z');
    std::cout << "After pushing 'z': " << doubleQueueStack << std::endl;
    bonus2 << "After pushing 'z': " << doubleQueueStack;
}

void checkPostfixExpressionEvaluation() {
	std::cout << "========== Postfix expression evaluation (bonus) ==========\n";
}

int main() {
    /*Uncomment any of the following function calls to run a single task*/

    // checkStack();
    // checkQueue();
    // checkBalancedParentheses();
    // checkRadixSort();
    // checkReverseQueue();
    // checkDoubleStackQueue();
    // checkPostfixExpressionEvaluation();

    return 0;
}
